package test.roaster;

import java.io.Serializable;

import org.jboss.forge.roaster.Roaster;
import org.jboss.forge.roaster.model.source.JavaClassSource;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

public class RunJavaParser implements BundleActivator {

	@Override
	public void start(BundleContext context) throws Exception {
		final JavaClassSource javaClass = Roaster.create(JavaClassSource.class);
		javaClass.setPackage("com.company.example").setName("Person");

		javaClass.addInterface(Serializable.class);
		javaClass.addField()
		  .setName("serialVersionUID")
		  .setType("long")
		  .setLiteralInitializer("1L")
		  .setPrivate()
		  .setStatic(true)
		  .setFinal(true);

		javaClass.addProperty(Integer.class, "id").setMutable(false);
		javaClass.addProperty(String.class, "firstName");
		javaClass.addProperty("String", "lastName");

		javaClass.addMethod()
		  .setConstructor(true)
		  .setPublic()
		  .setBody("this.id = id;")
		  .addParameter(Integer.class, "id");		
		
		System.out.println("Test Roaster");
		System.out.println("------------");
		System.out.println(javaClass);
		System.out.println("------------");
		
	}

	@Override
	public void stop(BundleContext context) throws Exception {
		// Nothing
	}

}
